<template>
  <div class="sidebar">
    <el-dialog
      v-model="visible"
      destroy-on-close
      width="100%"
      custom-class="sidebar-dialog"
      :show-close="false"
    >
      <template #title>
        <div class="h-fit">
          <div class="relative">
            <div class="flex justify-start h-[80px] items-center">
              <h2
                class="text-center text-[24px] text-[var(--title-font-color)] uppercase leading-1 font-bold mr-10 ml-4"
              >
                {{ $t("game_providers") }}
              </h2>
            </div>
            <div
              class="absolute top-[12px] right-0 bg-[var(--button-bg)] box-shadow text-[var(--title-font-color)] rounded-[6px] h-10 w-10 flex items-center justify-center"
            >
              <font-awesome-icon
                class="text-[27px]"
                icon="xmark"
                @click="close"
              />
            </div>
          </div>
        </div>
      </template>
      <div class="mt-[.5rem] px-4 pb-3">
        <ul class="grid grid-cols-2 gap-[20px] my-0 pl-0">
          <li
            v-for="provider in providers"
            :key="provider.ProviderName"
            class="w-auto text-center overflow-hidden leading-[1.5] py-[10px] px-2 bg-[var(--button-bg)] box-shadow rounded-lg relative"
            :class="{
              'grayscale-[1] pointer-events-none': provider.IsMaintain,
            }"
          >
            <div @click="handleProviderClicked(provider.ProviderName)">
              <div
                class="mb-[10px] h-20 p-[5px] border-[var(--border-color)] border-b-[1px] flex justify-center"
              >
                <img
                  class="object-scale-down max-h-full max-w-full"
                  :src="
                    getAssetImage(
                      `assets/theme/black_modern_1/images/gameProviders/${provider.ProviderName.split(
                        ' '
                      ).join('')}.png`
                    )
                  "
                  alt=""
                />
              </div>
              <div
                v-if="provider.IsMaintain"
                class="absolute w-12 h-12 top-[20px] left-[55px] z-[2]"
              >
                <img
                  :src="
                    getAssetImage(
                      'assets/theme/common/icon/icon_maintainance.png'
                    )
                  "
                  alt=""
                />
              </div>
              <p
                class="flex justify-between items-center text-[var(--title-font-color)] mb-0"
              >
                <span
                  class="text-sm overflow-hidden overflow-ellipsis whitespace-nowrap max-w-[90%]"
                >
                  {{ provider.GameProviderDisplayName }}
                </span>
                <font-awesome-icon
                  class="text-2xl leading-[14px]"
                  icon="arrow-right"
                />
              </p>
            </div>
          </li>
        </ul>
      </div>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import commonHelper from "@/utils/commonHelper";
import { useGameEntryComponent } from "@/composables/useTheme";

export default defineComponent({
  props: {
    dialogVisible: {
      type: Boolean,
      required: true,
    },
    handleClick: {
      type: Function,
      required: false,
      default: () => {},
    },
  },
  emits: ["update:dialogVisible"],
  setup(props, { emit }) {
    const { providers } = useGameEntryComponent();
    const { dialogVisible: visible } = toRefs(props);
    const { getAssetImage } = commonHelper;
    const router = useRouter();
    const close = () => {
      emit("update:dialogVisible", false);
    };
    const handleProviderClicked = (path: string) => {
      emit("update:dialogVisible", false);
      router.push(`/games/${path}__n__gp`);
      props.handleClick?.();
    };

    return {
      handleProviderClicked,
      getAssetImage,
      close,
      visible,
      providers,
    };
  },
});
</script>
